'mdDictionary - by MOD
'2014

'http://docs.oracle.com/javase/6/docs/api/java/util/Dictionary.html


#Include Once "md/util/mdMap.bi"
#Include Once "md/util/mdEnumeration.bi"

#Define mdDictionaryPtr(K, PK, V, PV) mdDictionary##K##PK##V##PV
#Define mdDictionary(K, V) mdDictionaryPtr(K, , V, )

#Macro mdDictionaryDeclarePtrPtr(K, PK, V, PV)

mdMapDeclarePtr(K, PK, V, PV)
mdEnumerationDeclarePtr(K, PK)
mdEnumerationDeclarePtr(V, PV)

#Ifndef mdDictionary##K##PK##V##PV
'#Define __MDDICTIONARY_BI__

Type mdDictionary##K##PK##V##PV Extends mdMap##K##PK##V##PV
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef m As mdDictionary##K##PK##V##PV)
	Declare Virtual Destructor ()
	
	Declare Virtual Function elements() As mdEnumerationPtr(V, PV)
	Declare Virtual Function getClass() As String
	Declare Virtual Function keys() As mdEnumerationPtr(K, PK)
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdDictionary##K##PK##V##PV)
End Type

Constructor mdDictionary##K##PK##V##PV()
	
End Constructor

Constructor mdDictionary##K##PK##V##PV(ByRef m As mdDictionary##K##PK##V##PV)
	This.putAll(m)
End Constructor

Destructor mdDictionary##K##PK##V##PV()
	This.clear()
End Destructor

Function mdDictionary##K##PK##V##PV.elements() As mdEnumerationPtr(V, PV)
	Dim As mdCollection(V, PV) temp = This.values()
	Dim As mdEnumeration(V, PV) e = temp
	Return e
End Function

Function mdDictionary##K##PK##V##PV.getClass() As String
	Return "mdDictionary(" & #K & ", " & IIf(Len(#PK) OrElse Len(#PV), #PK, #V) & IIf(Len(#PK) OrElse Len(#PV), ", " & #V & ", " & #PV, "") & ")"
End Function

Function mdDictionary##K##PK##V##PV.keys() As mdEnumerationPtr(K, PK)
	Dim As mdSet(K, PK) temp = This.keySet()
	Dim As mdEnumeration(K, PK) e = temp
	Return e
End Function

Operator mdDictionary##K##PK##V##PV.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdDictionary##K##PK##V##PV.Cast() As String
	Return This.toString()
End Operator

Operator mdDictionary##K##PK##V##PV.Let(ByRef c As mdDictionary##K##PK##V##PV)
	This.clear()
	This.putAll(c)
End Operator

Operator = (ByRef lhs As mdDictionary##K##PK##V##PV, ByRef rhs As mdDictionary##K##PK##V##PV) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDDICTIONARY_BI__

#EndMacro

#Define mdDictionaryDeclare(K, V) mdDictionaryDeclarePtrPtr(K, , V, )
#Define mdDictionaryDeclarePtr(K, PK, V, PV) mdDictionaryDeclarePtrPtr(K, PK, V, PV)
